'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _QueryBuilderOperation = require('./QueryBuilderOperation');

var _QueryBuilderOperation2 = _interopRequireDefault(_QueryBuilderOperation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JoinRelationOperation = function (_QueryBuilderOperatio) {
  (0, _inherits3.default)(JoinRelationOperation, _QueryBuilderOperatio);

  function JoinRelationOperation(builder, name, opt) {
    (0, _classCallCheck3.default)(this, JoinRelationOperation);

    var _this = (0, _possibleConstructorReturn3.default)(this, _QueryBuilderOperatio.call(this, builder, name, opt));

    _this.joinOperation = opt.joinOperation;
    _this.relationName = null;
    _this.callOpt = null;
    return _this;
  }

  JoinRelationOperation.prototype.call = function call(builder, args) {
    this.relationName = args[0];
    this.callOpt = args[1] || {};
    return true;
  };

  JoinRelationOperation.prototype.onBeforeBuild = function onBeforeBuild(builder) {
    var relation = builder.modelClass().getRelation(this.relationName);
    var alias = null;

    if (this.callOpt.alias === false) {
      alias = relation.relatedModelClass.tableName;
    } else if (this.callOpt.alias === true || !this.callOpt.alias) {
      alias = relation.name;
    } else if (_lodash2.default.isString(this.callOpt.alias)) {
      alias = this.callOpt.alias;
    }

    relation.join(builder, this.joinOperation, alias);
  };

  return JoinRelationOperation;
}(_QueryBuilderOperation2.default);

exports.default = JoinRelationOperation;