'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _WrappingQueryBuilderOperation = require('./WrappingQueryBuilderOperation');

var _WrappingQueryBuilderOperation2 = _interopRequireDefault(_WrappingQueryBuilderOperation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WhereCompositeOperation = function (_WrappingQueryBuilder) {
  (0, _inherits3.default)(WhereCompositeOperation, _WrappingQueryBuilder);

  function WhereCompositeOperation() {
    (0, _classCallCheck3.default)(this, WhereCompositeOperation);
    return (0, _possibleConstructorReturn3.default)(this, _WrappingQueryBuilder.apply(this, arguments));
  }

  WhereCompositeOperation.prototype.onBuild = function onBuild(knexBuilder) {
    if (this.args.length === 2) {
      this.whereComposite(knexBuilder, this.args[0], '=', this.args[1]);
    } else if (this.args.length === 3) {
      this.whereComposite(knexBuilder, this.args[0], this.args[1], this.args[2]);
    } else {
      throw new Error('invalid number of arguments ' + this.args.length);
    }
  };

  WhereCompositeOperation.prototype.whereComposite = function whereComposite(knexBuilder, cols, op, values) {
    var colsIsArray = _lodash2.default.isArray(cols);
    var valuesIsArray = _lodash2.default.isArray(values);

    if (!colsIsArray && !valuesIsArray) {
      knexBuilder.where(cols, op, values);
    } else if (colsIsArray && cols.length === 1 && !valuesIsArray) {
      knexBuilder.where(cols[0], op, values);
    } else if (colsIsArray && valuesIsArray && cols.length === values.length) {
      _lodash2.default.each(cols, function (col, idx) {
        return knexBuilder.where(col, op, values[idx]);
      });
    } else {
      throw new Error('both cols and values must have same dimensions');
    }
  };

  return WhereCompositeOperation;
}(_WrappingQueryBuilderOperation2.default);

exports.default = WhereCompositeOperation;