'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _WrappingQueryBuilderOperation = require('./WrappingQueryBuilderOperation');

var _WrappingQueryBuilderOperation2 = _interopRequireDefault(_WrappingQueryBuilderOperation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WhereInCompositeOperation = function (_WrappingQueryBuilder) {
  (0, _inherits3.default)(WhereInCompositeOperation, _WrappingQueryBuilder);

  function WhereInCompositeOperation() {
    (0, _classCallCheck3.default)(this, WhereInCompositeOperation);
    return (0, _possibleConstructorReturn3.default)(this, _WrappingQueryBuilder.apply(this, arguments));
  }

  WhereInCompositeOperation.prototype.onBuild = function onBuild(knexBuilder) {
    this.whereInComposite(knexBuilder, this.args[0], this.args[1]);
  };

  WhereInCompositeOperation.prototype.whereInComposite = function whereInComposite(knexBuilder, columns, values) {
    var _this2 = this;

    var isCompositeKey = _lodash2.default.isArray(columns) && columns.length > 1;

    if (isCompositeKey) {
      if (_lodash2.default.isArray(values)) {
        return knexBuilder.whereIn(columns, values);
      } else {
        // Because of a bug in knex, we need to build the where-in query from pieces
        // if the value is a subquery.
        var sql = '(' + _lodash2.default.map(columns, function (col) {
          return _this2.formatter().wrap(col);
        }).join() + ')';
        knexBuilder.whereIn(this.raw(sql), values);
      }
    } else {
      var col = _lodash2.default.isString(columns) ? columns : columns[0];

      if (_lodash2.default.isArray(values)) {
        values = _lodash2.default.compact(_lodash2.default.flatten(values));
      }

      // For non-composite keys we can use the normal whereIn.
      knexBuilder.whereIn(col, values);
    }
  };

  return WhereInCompositeOperation;
}(_WrappingQueryBuilderOperation2.default);

exports.default = WhereInCompositeOperation;