'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _InsertOperation2 = require('../../queryBuilder/operations/InsertOperation');

var _InsertOperation3 = _interopRequireDefault(_InsertOperation2);

var _promiseUtils = require('../../utils/promiseUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ManyToManyInsertOperation = function (_InsertOperation) {
  (0, _inherits3.default)(ManyToManyInsertOperation, _InsertOperation);

  function ManyToManyInsertOperation(builder, name, opt) {
    (0, _classCallCheck3.default)(this, ManyToManyInsertOperation);

    var _this = (0, _possibleConstructorReturn3.default)(this, _InsertOperation.call(this, builder, name, opt));

    _this.relation = opt.relation;
    _this.owner = opt.owner;
    return _this;
  }

  ManyToManyInsertOperation.prototype.call = function call(builder, args) {
    var retVal = _InsertOperation.prototype.call.call(this, builder, args);

    this.relation.omitExtraProps(this.models);

    return retVal;
  };

  ManyToManyInsertOperation.prototype.onAfterQuery = function onAfterQuery(builder, inserted) {
    var _this2 = this;

    var maybePromise = _InsertOperation.prototype.onAfterQuery.call(this, builder, inserted);

    return (0, _promiseUtils.after)(maybePromise, function (inserted) {
      var ownerId = _this2.owner.$values(_this2.relation.ownerProp);
      var joinModels = _this2.relation.createJoinModels(ownerId, inserted);

      _this2.owner[_this2.relation.name] = _this2.relation.mergeModels(_this2.owner[_this2.relation.name], inserted);

      // Insert the join rows to the join table.
      return _this2.relation.joinTableModelClass.bindKnex(builder.knex()).query().childQueryOf(builder).insert(joinModels).return(inserted);
    });
  };

  return ManyToManyInsertOperation;
}(_InsertOperation3.default);

exports.default = ManyToManyInsertOperation;