'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _QueryBuilderOperation = require('../../queryBuilder/operations/QueryBuilderOperation');

var _QueryBuilderOperation2 = _interopRequireDefault(_QueryBuilderOperation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sqliteBuiltInRowId = '_rowid_';

var ManyToManyUnrelateSqliteOperation = function (_QueryBuilderOperatio) {
  (0, _inherits3.default)(ManyToManyUnrelateSqliteOperation, _QueryBuilderOperatio);

  function ManyToManyUnrelateSqliteOperation(builder, name, opt) {
    (0, _classCallCheck3.default)(this, ManyToManyUnrelateSqliteOperation);

    var _this = (0, _possibleConstructorReturn3.default)(this, _QueryBuilderOperatio.call(this, builder, name, opt));

    _this.isWriteOperation = true;
    _this.relation = opt.relation;
    _this.owner = opt.owner;
    return _this;
  }

  ManyToManyUnrelateSqliteOperation.prototype.queryExecutor = function queryExecutor(builder) {
    var _this2 = this;

    var joinTableAlias = this.relation.joinTableAlias();
    var joinTableAsAlias = this.relation.joinTable + ' as ' + joinTableAlias;
    var joinTableAliasRowId = joinTableAlias + '.' + sqliteBuiltInRowId;
    var joinTableRowId = this.relation.joinTable + '.' + sqliteBuiltInRowId;

    var ownerId = this.owner.$values(this.relation.ownerProp);
    var fullRelatedCol = this.relation.fullRelatedCol();

    var selectRelatedQuery = this.relation.relatedModelClass.query().childQueryOf(builder).copyFrom(builder, /where/i).select(joinTableAliasRowId).modify(this.relation.filter).whereComposite(this.relation.fullJoinTableOwnerCol(), ownerId).join(joinTableAsAlias, function (join) {
      _lodash2.default.each(_this2.relation.fullJoinTableRelatedCol(), function (joinTableRelatedCol, idx) {
        join.on(joinTableRelatedCol, fullRelatedCol[idx]);
      });
    });

    return this.relation.joinTableModelClass.bindKnex(builder.knex()).query().childQueryOf(builder).delete().whereIn(joinTableRowId, selectRelatedQuery).runAfter(_lodash2.default.constant({}));
  };

  return ManyToManyUnrelateSqliteOperation;
}(_QueryBuilderOperation2.default);

exports.default = ManyToManyUnrelateSqliteOperation;