'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = hiddenDataGetterSetter;

var _hiddenData = require('../hiddenData');

function hiddenDataGetterSetter(propName) {
  var getHiddenData = (0, _hiddenData.createHiddenDataGetter)(propName);
  var setHiddenData = (0, _hiddenData.createHiddenDataSetter)(propName);

  return function (target, property, descriptor) {
    descriptor.value = function () {
      if (arguments.length === 0) {
        return getHiddenData(this);
      } else {
        setHiddenData(this, arguments[0]);
      }
    };
  };
}