'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ModelClass, obj) {
  if (QueryBuilderBase === null) {
    // Lazy loading to prevent circular deps.
    QueryBuilderBase = require('../queryBuilder/QueryBuilderBase').default;
  }

  var needsSplit = _lodash2.default.some(obj, function (value) {
    return value instanceof KnexQueryBuilder || value instanceof QueryBuilderBase || value instanceof KnexRaw;
  });

  if (needsSplit) {
    return split(obj);
  } else {
    return { json: obj, query: null };
  }
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var KnexQueryBuilder = require('knex/lib/query/builder');
var KnexRaw = require('knex/lib/raw');
var QueryBuilderBase = null;

function split(obj) {
  var ret = { json: {}, query: {} };

  _lodash2.default.each(obj, function (value, key) {
    if (value instanceof KnexQueryBuilder || value instanceof KnexRaw) {
      ret.query[key] = value;
    } else if (value instanceof QueryBuilderBase) {
      ret.query[key] = value.build();
    } else {
      ret.json[key] = value;
    }
  });

  return ret;
}